from django.shortcuts import render
from django.views.decorators.csrf import csrf_exempt
import stripe
import json
from datetime import datetime
from django.http import HttpResponse
from payment.models import Subcription_Info_Model
from payment.stripe import createSubscription_debit, getSessionPaymentMethod

#Using Django
#stripe listen --forward-to localhost:8000/webhook/
@csrf_exempt
def my_webhook_view(request):
    payload = request.body
    event = None
    data = None
    try:
        event = stripe.Event.construct_from(
            json.loads(payload), stripe.api_key
        )
    except ValueError as e:
        print("Exception: ",e)
        return HttpResponse(status=400)

    # Handle the event
    if event.type == 'payment_intent.succeeded':
        """
        For Receipt generated by Stripe over successful Payment
        """
        data = event.data.object

        #type of payment
        payment_type = data.charges.data[0].payment_method_details.type
        
        #Receipt generated by Stripe
        receipt_url = data.charges.data[0].receipt_url
        
        # ... handle other event types
    

    elif event.type == 'payment_intent.payment_failed':
        """
        Handle Failed Payment

        """
        data = event.data.object

        #type of payment failed
        payment_type = data.charges.data[0].payment_method_details.type

        #failure code for failed payment
        failure_code = data.charges.data[0].failure_code

        #failure message for failed payment
        failure_message= data.charges.data[0].failure_message

        #outcome gives detailed review regarding failed payment
        outcome = data.charges.data[0].outcome
        """
        "outcome": {
          "network_status": "declined_by_network",
          "reason": "generic_decline",
          "risk_level": "normal",
          "risk_score": 61,
          "seller_message": "The bank did not return any further details with this decline.",
          "type": "issuer_declined"
        },
        """
        print(payment_type, failure_code, failure_message, outcome)

     
    elif event.type == 'checkout.session.completed':
        """
        Handle Checkout Session Completed
        Payment Initiated
        """
        data = event.data.object


    elif event.type == 'checkout.session.async_payment_succeeded':
        """
        Checkout Session Payment Succeeded
        """
        data = event.data.object

        #amount paid in the transaction
        amount_total = data.amount_total

        #currency of transaction
        currency = data.currency

        #customer detail of current transaction
        customer_id = data.customer

    elif event.type == 'checkout.session.async_payment_failed':
        """
        Checkout Session Payment Failed
        """
        data = event.data.object

        #amount paid in the transaction
        amount_total = data.amount_total

        #currency of transaction
        currency = data.currency

        #customer detail of current transaction
        customer_id = data.customer

    elif event.type == 'payment_intent.canceled':
        data = event.data.object
        payment_intent_id = data.data.id
        status = data.status
        #check if payment_intent_id is in invoice table and if status in table is initiated
        # then yes > set status = status
        # else leave it

    else:
        print('Unhandled event type {}'.format(event.type))
    data = None
    return HttpResponse(status=200)